;	PCGA.ASM
;	1995.8.6

SEG_A		SEGMENT
		ASSUME	CS:SEG_A, DS:SEG_A

		ORG	100H
START:		JMP	BEGIN

D_INT5		DD	0
D_FDBS		DB	0
D_ZZ		DB	'`&16`',13,10,'$'
D_DX		DB	'`>`$'
D_SX		DB	'`<`$'
D_TX		DB	1BH,'I'
D_TX1		DW	0
		DB	'$'

INT_5		PROC	FAR
		STI
		CLD
		PUSH	DS
		PUSH	ES
		PUSH	BP
		PUSH	SI
		PUSH	DI
		PUSH	AX
		PUSH	BX
		PUSH	CX
		PUSH	DX
		PUSH	CS
		POP	DS
		MOV	AX,1406H
		INT	10H
		CMP	AL,4
		JB	L_10
		CMP	AL,6
		JBE	L_20
L_10:
		PUSHF
		CALL	D_INT5
		JMP	SHORT L_70
L_20:
		MOV	ES,BP
		MOV	AL,0AH
		CALL	S_PAL
		CALL	S_DX
		MOV	AX,0C8H
		MOV	DL,D_FDBS
		XOR	DH,DH
		MUL	DX
		MOV	DL,0CH
		DIV	DL
		OR	AH,AH
		JZ	L_30
		INC	AX
		XOR	AH,AH
L_30:
		MOV	CX,AX
		XOR	DI,DI
L_40:
		MOV	AH,1
		INT	16H
		JZ	L_50
		XOR	AH,AH
		INT	16H
		OR	AX,AX
		JZ	L_60
L_50:
		CALL	S_TX
		CALL	S_CL
		LOOP	L_40
L_60:
		CALL	S_SX
L_70:
		POP	DX
		POP	CX
		POP	BX
		POP	AX
		POP	DI
		POP	SI
		POP	BP
		POP	ES
		POP	DS
		IRET
INT_5		ENDP

;ӳ:һ
S_CL		PROC	NEAR
		PUSH	CX
		PUSH	DI
		MOV	CX,80
L_CL1:
		PUSH	CX
		MOV	CL,8
L_CL2:
		MOV	DX,18H
		PUSH	DI
L_CL3:
		CALL	S_DL
		PUSH	DI
		ADD	DI,2000H
		CALL	S_DL
		POP	DI
		ADD	DI,50H
		OR	DL,DL
		JNZ	L_CL3
		PUSH	CX
		MOV	CL,D_FDBS
L_CL4:
		MOV	AL,DS:[100H]
		CALL	S_PAL
		MOV	AL,DS:[101H]
		CALL	S_PAL
		MOV	AL,DS:[102H]
		CALL	S_PAL
		LOOP	L_CL4
		POP	CX
		POP	DI
		LOOP	L_CL2
		INC	DI
		POP	CX
		LOOP	L_CL1
		POP	DI
		CALL	S_ZZ
		MOV	AX,6
		DIV	D_FDBS
		MOV	DL,50H			; 'P'
		MUL	DL
		ADD	DI,AX
		POP	CX
		RET
S_CL		ENDP

;ӳ:һ
S_DL		PROC	NEAR
		MOV	BL,D_FDBS
		SHL	BL,1
L_DL1:
		MOV	AH,ES:[DI]
		SHR	AH,CL
		RCL	BH,1
		DEC	DL
		TEST	DL,7
		JNZ	L_DL2
		MOV	AL,DH
		CBW
		MOV	SI,AX
		MOV	DS:[SI+100H],BH
		INC	DH
L_DL2:
		DEC	BL
		JNZ	L_DL1
		RET
S_DL		ENDP

S_ZZ		PROC	NEAR
		MOV	SI,OFFSET D_ZZ
		JMP	SHORT L_ZZ1
S_DX:
		MOV	SI,110H
		JMP	SHORT L_ZZ1
S_SX:
		MOV	SI,114H
		JMP	SHORT L_ZZ1
S_TX:
		MOV	SI,118H
L_ZZ1:
		LODSB
		CMP	AL,24H			; '$'
		JZ	L_ZZ2
		CALL	S_PAL
		JMP	SHORT L_ZZ1
L_ZZ2:
		RET
S_ZZ		ENDP

;ӳ:һֽ
S_PAL		PROC	NEAR
		XOR	AH,AH
		PUSH	DX
		XOR	DX,DX
		INT	17H
		POP	DX
		RET
S_PAL		ENDP

;----------------------------------------------------------------------------
BEGIN:
		CMP	BYTE PTR DS:[80H],1
		JAE	L_S10
		MOV	DX,OFFSET D_ERR
		MOV	AH,9
		INT	21H
		INT	20H
L_S10:
		MOV	AX,3505H
		INT	21H
		CMP	BX,OFFSET INT_5
		JZ	L_S20
		MOV	WORD PTR D_INT5,BX
		MOV	WORD PTR D_INT5+2,ES
		PUSH	CS
		POP	ES
L_S20:
		MOV	AL,DS:[5DH]
		CMP	AL,'P'
		JNZ	L_S30
		MOV	AL,DS:[6DH]
L_S30:
		CMP	AL,'1'
		JB	L_S40
		CMP	AL,'4'
		JBE	L_S50
L_S40:
		MOV	AL,'2'
L_S50:
		AND	AL,0FH
		MOV	ES:D_FDBS,AL
		CBW
		MOV	DX,280H
		MUL	DX
		XCHG	AH,AL
		MOV	ES:D_TX1,AX
		CMP	BX,OFFSET INT_5
		JNZ	L_S60
		INT	20H
L_S60:
		MOV	DX,OFFSET INT_5
		MOV	AX,2505H
		INT	21H
		MOV	DX,OFFSET BEGIN
		INT	27H

D_ERR		DB	'ʽ:PCGA a',13,10
		DB	':aΪŴ(1~4)',7,13,10,'$'

SEG_A		ENDS
		END	START
